'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/* global FileReader, fetch */
var AbstractFileReader = require('./AbstractFileReader');

var LocalFileReader = function (_AbstractFileReader) {
  _inherits(LocalFileReader, _AbstractFileReader);

  function LocalFileReader(file) {
    _classCallCheck(this, LocalFileReader);

    var _this = _possibleConstructorReturn(this, (LocalFileReader.__proto__ || Object.getPrototypeOf(LocalFileReader)).call(this));

    _this.file = file;
    _this.size = file.size;
    return _this;
  }

  _createClass(LocalFileReader, [{
    key: 'name',
    value: function name() {
      return this.file.name;
    }
  }, {
    key: 'bytes',
    value: function bytes() {
      var _this2 = this;

      var start = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var length = arguments[1];

      return new Promise(function (resolve, reject) {
        var lengthToRead = length === undefined ? _this2.size - start : length;
        var blob = _this2.file.slice(start, start + lengthToRead);

        var reader = new FileReader();
        reader.onload = function () {
          resolve(reader.result);
        };
        reader.onerror = function () {
          reject(reader.error);
        };
        reader.readAsArrayBuffer(blob);
      });
    }
  }]);

  return LocalFileReader;
}(AbstractFileReader);

var RemoteFileReader = function (_AbstractFileReader2) {
  _inherits(RemoteFileReader, _AbstractFileReader2);

  function RemoteFileReader(url) {
    _classCallCheck(this, RemoteFileReader);

    var _this3 = _possibleConstructorReturn(this, (RemoteFileReader.__proto__ || Object.getPrototypeOf(RemoteFileReader)).call(this));

    _this3.url = url;
    return _this3;
  }

  _createClass(RemoteFileReader, [{
    key: 'bytes',
    value: function bytes() {
      var _this4 = this;

      var start = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var length = arguments[1];

      var options = {
        method: 'GET'
      };

      if (start !== 0 || length !== undefined) {
        // Requesting only a portion of the file
        options.headers = {
          Range: length !== undefined ? 'bytes=' + start + '-' + (start + (length - 1)) : 'bytes=' + start + '-'
        };
      }

      // https://github.com/webtorrent/webtorrent/issues/1193
      // Chrome will attempt to fulfill portions of a range request from the cache
      // occasionally resulting a failed fetch. Automatically retry fetch once on
      // an error while setting options to bypass the cache.
      return new Promise(function (resolve, reject) {
        var wrappedFetch = function wrappedFetch(retry) {
          var addlOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

          fetch(_this4.url, Object.assign({}, options, addlOptions)).then(function (response) {
            if (response.ok) {
              resolve(response.arrayBuffer());
            } else {
              // Don't retry on HTTP error
              reject(new Error('Bad response from server'));
            }
          }).catch(function (error) {
            if (retry > 0) {
              wrappedFetch(retry - 1, Object.assign({}, addlOptions, { cache: 'reload' }));
            } else {
              reject(error);
            }
          });
        };
        wrappedFetch(1);
      });

      // return fetch(this.url, options).then((response) => {
      //   if (response.ok) {
      //     return response.arrayBuffer();
      //   }
      //   throw new Error('Bad response from server');
      // });
    }
  }]);

  return RemoteFileReader;
}(AbstractFileReader);

module.exports = {
  LocalFileReader: LocalFileReader,
  RemoteFileReader: RemoteFileReader
};